<?php
function getEntryHits($target, $mother){
	global $database, $suri, $blogid, $entryView, $configVal;
	getEntryHitsTableCheck();
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	if((($suri['directive']=='/' || $suri['directive']=='/entry') && $suri['value'] != '') && !doesHaveOwnership()) getHitsProcess($mother);
	$hitCount = POD::queryCell("SELECT hits FROM {$database['prefix']}Entries_hits WHERE blogid = {$blogid} AND entry = {$mother}");

	$hitCountLength = strlen($hitCount);
	$hitCount = $hitCount ? "$hitCount" : 0;
	if(!isset($data['number_marking'])) $markingLength = 0; else $markingLength=$data['number_marking'];

	$hitCountHeader = isset($data['hitsCountHeader']) ? $data['hitsCountHeader'] : '';
	$hitCountFooter = isset($data['hitsCountFooter']) ? $data['hitsCountFooter'] : '';

	if($markingLength && $hitCountLength>$markingLength) {	// 조회 수 세 자리 또는 네 자리씩 끊기
		$markingSign = isset($data['marking_marking_sign']) ? isset($data['marking_marking_sign']) : '′';
		$hitCountCuts = (integer) $hitCountLength/$markingLength;
		$markedHitCount = '';
		for($i=0;$i<$hitCountCuts;++$i) {
			$markedHitCount .= substr($hitCount, ((bool)$i)*(($i-1)*$$markingLength+$hitCountLength%$markingLength), !$i ? $hitCountLength%$markingLength:$markingLength);
			$markedHitCount .= $markingSign;
		}
		$markedHitCount = substr($markedHitCount,0,strlen($markedHitCount)-strlen($markingSign));
		$hitCount = $markedHitCount;
	}

	$hitsView = "<span id=\"hitsView{$mother}\">{$hitCountHeader}{$hitCount}{$hitCountFooter}</span>";
	misc::dress('HitsView', $hitsView, $entryView);
	return $target;
}

function getHitsProcess($id){
	global $database, $blogid, $blogURL, $suri;
	$hitsrows = POD::queryCell("SELECT hits FROM {$database['prefix']}Entries_hits WHERE blogid = {$blogid} AND entry = {$id}");
	if ($hitsrows){
		if($_COOKIE['entryViewHit'] != getHitsAnonymousSession()){
			POD::execute("UPDATE {$database['prefix']}Entries_hits SET hits = hits+1 WHERE blogid = {$blogid} AND entry = {$id}");
			ob_start();
				SetCookie('entryViewHit', getHitsAnonymousSession() , 0, $suri['url']);
			ob_end_flush();
		}
	}else{
		POD::execute("INSERT INTO {$database['prefix']}Entries_hits (blogid, entry, hits) values ({$blogid}, {$id}, 1)");
		ob_start();
			setcookie('entryViewHit', getHitsAnonymousSession() , 0, $suri['url']);
		ob_end_flush();
	}
	return true;
}

function getEntryHitsDelete($target, $mother) {
	global $database, $blogid;
	$id = $target;
	if ($id > 0) {
		POD::execute("DELETE FROM {$database['prefix']}Entries_hits WHERE blogid = $blogid AND entry = $id");
	}
	return $target;
}

function getHitsAnonymousSession() {
	global $database;
	$result = sessionHitsQuery("SELECT id FROM {$database['prefix']}Sessions WHERE address = '{$_SERVER['REMOTE_ADDR']}' AND userid IS NULL AND preexistence IS NULL");
	if ($result)
		return $result;
	return false;
}

function sessionHitsQuery($sql) {
	global $database, $sessionDBRepair;
	$result = POD::queryCell($sql);
	if($result === false) {
		if (!isset($sessionDBRepair)) {
			POD::query("REPAIR TABLE {$database['prefix']}Sessions");
			$result = POD::queryCell($sql);
			$sessionDBRepair = true;
		}
	}
	return $result;
}

function getHitsRankingEntryList($parameter){
	global $database, $blogid, $blog, $pluginURL, $blogURL, $configVal;
	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "글 목록을 조회 순으로 옆막대에 출력해서 보여줍니다.";
		return $retval;
	}
	getEntryHitsTableCheck();
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		$data['listLength']		= 8;
		$data['titleLength']	= 33;
		$data['commentView']	= 2;
		$data['dateCheck']		= 2;
		$data['dateLimit']		= '';
		$data['dateStart']		= '';
		$data['dateEnd']		= '';
		$data['rankIcon']		= 0;
		$data['hitsSidebarListHeader']	= '<div class="listbox">'.CRLF.'<h3>많이 본 글</h3>';
		$data['hitsSidebarListFooter']	= '</div>';
	}

	$dateStart	= '';
	$dateEnd	= '';
	$dateLimit	= '';
	$rankicon	= '';
	$i = 0;
	$rep_commtent = '';
	if($data['dateLimit']){
		$dateStart = strtotime(date('Y-m-d',time())." -{$data['dateLimit']} days");
		$dateEnd = time();
	}
	if($data['dateStart'] || $data['dateEnd']){
		$dateStart = ($data['dateStart'])?strtotime($data['dateStart']):'';
		if($data['dateEnd']){
			$dateEnd = (strtolower($data['dateEnd']) == 'today')?time():strtotime($data['dateEnd']);
		}else{
			$dateEnd = '';
		}

	}
	if($data['dateCheck'] == 1 && $dateStart && $dateEnd) {
		$dateLimit = ' AND (e.published >= '.$dateStart.' AND e.published <= '.$dateEnd.') ';
	}
	$dataCnt = POD::queryCell("SELECT COUNT(*) FROM {$database['prefix']}Entries_hits WHERE blogid = {$blogid}");
	$data['listLength'] = ($data['listLength'] && $dataCnt)?" LIMIT {$data['listLength']} ":'';
	$visibility = doesHaveOwnership()?'':'AND e.visibility > 0';
	$result = POD::queryAll("SELECT e.id, e.title, e.slogan, e.comments, c.hits, MAX(c.entry) FROM {$database['prefix']}Entries e LEFT JOIN {$database['prefix']}Entries_hits c ON e.id = c.entry AND e.blogid = c.blogid WHERE e.blogid = {$blogid} AND e.draft = 0 {$visibility} AND e.category >= 0 AND c.entry IS NOT NULL {$dateLimit} GROUP BY c.entry ORDER BY c.hits DESC {$data['listLength']}");
	$rankicon = ($data['rankIcon'] == 1)?' style="margin:4px 0px 0px 0px;padding:0px;list-style:none;margin-left:1px;"':'';
	$target  = ($data['hitsSidebarListHeader'])?$data['hitsSidebarListHeader']:'<div class="listbox">'.CRLF.'<h3>hits entry list</h3>'.CRLF;
	$target .= '<div id="hitsEntry">'.CRLF;
	$target .= '<ul '.$rankicon.'>'.CRLF;
	foreach ($result as $entry){
		$i++;
		$permalink =($blog['useSlogan']?$blogURL.'/entry/'.$entry['slogan']:$blogURL.'/'.$entry['id']);
		$rep_title = htmlspecialchars(UTF8::lessenAsEm($entry['title'], $data['titleLength']));
		if($data['commentView'] == 1) $rep_commtent = ($entry['comments'])?"<span class=\"cnt\">({$entry['comments']})</span>":'';
		$rankicon = ($data['rankIcon'] == 1)?" style=\"background:url({$pluginURL}/icon/{$i}.gif) no-repeat 0px 3px;padding-left:13px;\"":'';
		$target .= "<li {$rankicon}><a href=\"{$permalink}\">{$rep_title}</a> {$rep_commtent} </li>".CRLF;
	}
	$target .= '</ul>'.CRLF;
	$target .= '</div>'.CRLF;
	$target .= ($data['hitsSidebarListFooter'])?$data['hitsSidebarListFooter']:'</div>';
	return $target;
}

function getEntryHitsTableCheck(){
	global $database;
	if (POD::queryExistence("DESC {$database['prefix']}Entries_hits id")) {
		POD::execute("ALTER TABLE {$database['prefix']}Entries_hits DROP id");
	}

	if(POD::queryExistence("DESC {$database['prefix']}Entries_hits owner")){
		POD::execute("ALTER TABLE {$database['prefix']}Entries_hits CHANGE owner blogid int(11) NOT NULL DEFAULT 0");
	}
}

function HitsRankingEntryListDataSet($data){
	getEntryHitsTableCheck();
	requireComponent('Textcube.Function.misc');
	$cfg = misc::fetchConfigVal($data);
	if($cfg['dateLimit'] && ($cfg['dateStart'] || $cfg['dateEnd'])) return '::입력 오류::\n\n\'특정일수\'와 \'시작/끝날 날짜\' 항목은 함께 사용할 수 없습니다.   ';
	if($cfg['dateStart'] && !$cfg['dateEnd']) return '::입력 오류::\n\n\'끝날 날짜\' 항목을 입력하셔야 합니다.   ';
	if(!$cfg['dateStart'] && $cfg['dateEnd']) return '::입력 오류::\n\n\'시작 날짜\' 항목을 입력하셔야 합니다.   ';
	return true;
}
?>